## openmpi 5.0.9

=== contrib/windows-cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(hwloc
    LANGUAGES C
    VERSION 2.7.1)

enable_testing()

option(HWLOC_ENABLE_TESTING "Enable testing" ON)
option(HWLOC_SKIP_LSTOPO "don't build/install lstopo")
option(HWLOC_SKIP_TOOLS "don't build/install other hwloc tools")
option(HWLOC_SKIP_INCLUDES "don't install headers")
option(HWLOC_WITH_LIBXML2 "use libxml2 instead of minimal XML")
option(HWLOC_WITH_OPENCL "enable OpenCL support")
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.17)
    option(HWLOC_WITH_CUDA "enable CUDA support")
endif()
option(HWLOC_BUILD_SHARED_LIBS "build shared libraries" ${BUILD_SHARED_LIBS})

set(TOPDIR ${PROJECT_SOURCE_DIR}/../..)

# "libhwloc.*" naming for MSVC and non-MSVC

configure_file(${TOPDIR}/contrib/windows/hwloc_config.h include/hwloc/autogen/config.h COPYONLY)

# Configure dynamically based on platform capabilities
include(CheckIncludeFile)
include(CheckSymbolExists)
include(CheckCSourceCompiles)

check_include_file("dirent.h" HAVE_DIRENT_H)
check_include_file("unistd.h" HAVE_UNISTD_H)
check_include_file("malloc.h" HAVE_MALLOC_H)
check_include_file("memory.h" HAVE_MEMORY_H)

check_symbol_exists(mkstemp "stdlib.h" HAVE_MKSTEMP)
check_symbol_exists(memalign "malloc.h" HAVE_MEMALIGN)

check_symbol_exists(strncasecmp "strings.h" HAVE_STRNCASECMP)
if(MSVC AND HAVE_STRNCASECMP)
    set(hwloc_strncasecmp 1)
    set(hwloc_strncasecmp_fcn strncasecmp)
else()
    set(hwloc_strncasecmp 0)
    set(hwloc_strncasecmp_fcn strncmp)
endif()


set(SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})
# disable x86 entirely by default
set(HWLOC_X86_32_ARCH)
set(HWLOC_X86_64_ARCH)
set(HWLOC_HAVE_X86_CPUID 1)
if (CMAKE_SYSTEM_PROCESSOR MATCHES "(^AMD64$|^x86_64$)")
    # "AMD64" on Windows, "x86_64" on Linux
    set(HWLOC_X86_64_ARCH 1)
elseif (CMAKE_SYSTEM_PROCESSOR MATCHES "(^x86$|i.86)")
    # "x86" on Windows, "i.86" on Linux
    set(HWLOC_X86_32_ARCH 1)
else()
    set(HWLOC_HAVE_X86_CPUID 0)
endif()

check_c_source_compiles("int main(void) {int cpuinfo[4]; __cpuidex(cpuinfo,0,0); return 0;}"
HWLOC_HAVE_MSVC_CPUIDEX
)

# the following lines are disabled until we are sure they are safe with old build environmentx
# - snprintf() returned broken values in the past, hwloc detects it during configure (see 7a4ee26510c06b55fc04aaccbfa18d0ca3b87198)
#   set(HAVE_DECL_SNPRINTF 1)
# - strtoull() had some issues in the past (see 9559bd08b79ef63dce45df87fb7f875b73ecb512)
#   set(HAVE_DECL_STRTOULL 1)

# --- optional external libraries
set(HWLOC_HAVE_LIBXML2)
if(HWLOC_WITH_LIBXML2)
    find_package(LibXml2 REQUIRED)
    set(HWLOC_HAVE_LIBXML2 1)
endif()

set(HWLOC_HAVE_OPENCL)
if(HWLOC_WITH_OPENCL)
    find_package(OpenCL REQUIRED)
    set(HWLOC_HAVE_OPENCL 1)
endif()

set(HAVE_CUDA)
set(HAVE_CUDA_H)
set(HAVE_CUDA_RUNTIME_API_H)
set(HWLOC_HAVE_CUDART)
if(HWLOC_WITH_CUDA)
    find_package(CUDAToolkit REQUIRED)
    set(HAVE_CUDA 1)
    set(HAVE_CUDA_H 1)
    set(HAVE_CUDA_RUNTIME_API_H 1)
    set(HWLOC_HAVE_CUDART 1)
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/private_config.h.in include/private/autogen/config.h)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/static-components.h.in include/static-components.h)

# Library

add_compile_definitions($<$<CONFIG:DEBUG>:HWLOC_DEBUG=1>)

# FIXME dll soname
add_library(hwloc
    ${TOPDIR}/hwloc/topology.c
    ${TOPDIR}/hwloc/traversal.c
    ${TOPDIR}/hwloc/distances.c
    ${TOPDIR}/hwloc/memattrs.c
    ${TOPDIR}/hwloc/cpukinds.c
    ${TOPDIR}/hwloc/components.c
    ${TOPDIR}/hwloc/bind.c
    ${TOPDIR}/hwloc/bitmap.c
    ${TOPDIR}/hwloc/pci-common.c
    ${TOPDIR}/hwloc/diff.c
    ${TOPDIR}/hwloc/shmem.c
    ${TOPDIR}/hwloc/misc.c
    ${TOPDIR}/hwloc/base64.c
    ${TOPDIR}/hwloc/topology-noos.c
    ${TOPDIR}/hwloc/topology-synthetic.c
    ${TOPDIR}/hwloc/topology-xml.c
    ${TOPDIR}/hwloc/topology-xml-nolibxml.c
    ${TOPDIR}/hwloc/topology-windows.c
    ${TOPDIR}/hwloc/topology-x86.c
    $<$<BOOL:${HWLOC_HAVE_LIBXML2}>:${TOPDIR}/hwloc/topology-xml-libxml.c>
    $<$<BOOL:${HWLOC_HAVE_OPENCL}>:${TOPDIR}/hwloc/topology-opencl.c>
    $<$<BOOL:${HAVE_CUDA}>:${TOPDIR}/hwloc/topology-cuda.c>
)

target_link_libraries(hwloc PRIVATE
    $<$<BOOL:${HWLOC_HAVE_LIBXML2}>:LibXml2::LibXml2>
    $<$<BOOL:${HWLOC_HAVE_OPENCL}>:OpenCL::OpenCL>
    "$<$<BOOL:${HAVE_CUDA}>:CUDA::cudart;CUDA::cuda_driver>"
)

if(HWLOC_BUILD_SHARED_LIBS)
    target_compile_definitions(hwloc PRIVATE $<$<BOOL:${MSVC}>:_USRDLL>)
endif()

target_include_directories(hwloc PUBLIC
    "$<BUILD_INTERFACE:${TOPDIR}/include;${CMAKE_CURRENT_BINARY_DIR}/include>"
    $<INSTALL_INTERFACE:include>
)

# Tools under utils/hwloc

if(NOT HWLOC_SKIP_TOOLS)

    set(TOOLS
        hwloc-bind
        hwloc-calc
        hwloc-diff
        hwloc-distrib
        hwloc-gather-cpuid
        hwloc-info
        hwloc-patch
    )

    foreach(tool IN ITEMS ${TOOLS})
        add_executable(${tool}
            ${TOPDIR}/utils/hwloc/${tool}.c)
        target_link_libraries(${tool} PRIVATE hwloc)
    endforeach(tool)

endif()

# lstopo

if(NOT HWLOC_SKIP_LSTOPO)

    set(LSTOPOS
        lstopo-no-graphics
        lstopo
        lstopo-win
    )

    set(LSTOPO_COMMON_SOURCES
        ${TOPDIR}/utils/lstopo/lstopo.c
        ${TOPDIR}/utils/lstopo/lstopo-draw.c
        ${TOPDIR}/utils/lstopo/lstopo-tikz.c
        ${TOPDIR}/utils/lstopo/lstopo-fig.c
        ${TOPDIR}/utils/lstopo/lstopo-svg.c
        ${TOPDIR}/utils/lstopo/lstopo-ascii.c
        ${TOPDIR}/utils/lstopo/lstopo-text.c
        ${TOPDIR}/utils/lstopo/lstopo-xml.c
        ${TOPDIR}/utils/hwloc/common-ps.c
    )

    add_executable(lstopo-no-graphics
        ${LSTOPO_COMMON_SOURCES}
    )
    target_link_libraries(lstopo-no-graphics PRIVATE hwloc)

    add_executable(lstopo
        ${LSTOPO_COMMON_SOURCES}
        ${TOPDIR}/utils/lstopo/lstopo-windows.c
    )
    target_compile_definitions(lstopo PRIVATE LSTOPO_HAVE_GRAPHICS)

    add_executable(lstopo-win WIN32
        ${LSTOPO_COMMON_SOURCES}
        ${TOPDIR}/utils/lstopo/lstopo-windows.c
    )
    target_compile_definitions(lstopo-win PRIVATE LSTOPO_HAVE_GRAPHICS)
    target_link_options(lstopo-win PRIVATE "$<$<BOOL:${MSVC}>:/subsystem:windows;/entry:mainCRTStartup>")

    foreach(tool IN ITEMS ${LSTOPOS})
        target_include_directories(${tool} PRIVATE ${TOPDIR}/utils/hwloc)
        target_link_libraries(${tool} PRIVATE hwloc)
    endforeach(tool)

endif()

# Misc

foreach(target IN ITEMS hwloc ${TOOLS} ${LSTOPOS})
    target_compile_definitions(${target} PRIVATE $<$<BOOL:${MSVC}>:_CRT_SECURE_NO_WARNINGS>)
endforeach(target)

# Install

install(TARGETS hwloc)

if(NOT HWLOC_SKIP_TOOLS)
    install(TARGETS ${TOOLS})
endif()

if(NOT HWLOC_SKIP_LSTOPO)
    install(TARGETS ${LSTOPOS})
endif()

if(NOT HWLOC_SKIP_INCLUDES)
    install(FILES ${TOPDIR}/include/hwloc.h TYPE INCLUDE)
    install(DIRECTORY ${TOPDIR}/include/hwloc TYPE INCLUDE FILES_MATCHING PATTERN "*.h")
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/include/hwloc/autogen/config.h DESTINATION include/hwloc/autogen)
endif()

if(HWLOC_ENABLE_TESTING)
    add_subdirectory(${TOPDIR}/tests/hwloc ${CMAKE_CURRENT_BINARY_DIR}/tests/hwloc)
endif()

=== 3rd-party/prrte/examples/Makefile ===
#
# Copyright (c) 2004-2005 The Trustees of Indiana University and Indiana
#                         University Research and Technology
#                         Corporation.  All rights reserved.
# Copyright (c) 2004-2005 The University of Tennessee and The University
#                         of Tennessee Research Foundation.  All rights
#                         reserved.
# Copyright (c) 2004-2005 High Performance Computing Center Stuttgart,
#                         University of Stuttgart.  All rights reserved.
# Copyright (c) 2004-2005 The Regents of the University of California.
#                         All rights reserved.
# Copyright (c) 2006-2007 Sun Microsystems, Inc.  All rights reserved.
# Copyright (c) 2011-2016 Cisco Systems, Inc.  All rights reserved.
# Copyright (c) 2012      Los Alamos National Security, Inc.  All rights reserved.
# Copyright (c) 2013      Mellanox Technologies, Inc.  All rights reserved.
# Copyright (c) 2016-2020 Intel, Inc.  All rights reserved.
# Copyright (c) 2021-2025 Nanook Consulting  All rights reserved.
# $COPYRIGHT$
#
# Additional copyrights may follow
#
# $HEADER$
#

# Use the PRRTE-provided wrapper compiler

CC = pcc

# Using -g is not necessary, but it is helpful for example programs,
# especially if users want to examine them with debuggers.

CFLAGS = -g

# Example programs to build

EXAMPLES = \
	client \
	client2 \
	debugger/direct \
	debugger/direct-multi \
	debugger/indirect \
	debugger/indirect-multi \
	debugger/attach \
	debugger/daemon \
	debugger/hello \
	debugger/stdincheck \
	dmodex \
	dynamic \
	fault \
	pub \
	tool \
	alloc \
	probe \
	target \
	hello \
	log \
	bad_exit \
	jctrl \
	launcher \
	showkeys \
	legacy \
	colocate \
	pset \
	nodeid \
	client-threaded \
|	abort

all: $(EXAMPLES)

# The usual "clean" target

clean:
	rm -f $(EXAMPLES) *~ *.o

=== debian/changelog ===
openmpi (5.0.9-2) experimental; urgency=medium

  * Drop MA:foreign from openmpi-bin (#1057727)
  * Ditto dropping MA: same from libopenmpi-dev. Closes: #983600
  * Drop obsolete breaks/replaces/conflicts
  * Drop Spurious build-dep on libpsm-infinipath1-dev. Closes: #1101509
  * Add salsa-ci.yml to enable CI automatically
  * Close previously fixed bug: Closes: #910251
  * Updated build_hurd patch from Drew Parsons. Closes: #1120217
  * B-D on sphinx-common for dh_sphinxdoc
  * d/watch now at version 4
  * Re-enable UCX by default in openmpi-mca-params.conf.
    Closes: #1094805
  * openmpi-bin.postinst/prerm: delete obsolete conffiles
  * Enable ucx for loong64. Closes: #1118105
  * openmpi-doc: dep on node-mathjax-full for tex-mml-chtml.js
  * privacy-mathjax.patch: Use local files not web

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 13 Dec 2025 14:49:55 +0000

openmpi (5.0.9-1) unstable; urgency=medium

  *  upstream release
  *  libprrte.so now at version 3.0.12
  * Use dh-fortran-sequence

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 12 Nov 2025 08:32:13 +0000

openmpi (5.0.8-10) unstable; urgency=medium

  * Revert to using external pmix, now its reverted to v5

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 18 Sep 2025 11:48:32 +0100

openmpi (5.0.8-9) unstable; urgency=medium

  * Fix patch update that didn't get included in -8 properly

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 08 Sep 2025 11:20:26 +0100

=== debian/control ===
Source: openmpi
Section: net
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>,
 Manuel Prinz <manuel@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), 
 architecture-is-64-bit,
 dh-sequence-fortran,
 debhelper-compat (= 13), 
 libevent-dev,
 libucx-dev [amd64 arm64 ppc64el riscv64 loong64],
 zlib1g-dev,
 gfortran-for-host,
 libhwloc-dev,
 libpmix-dev,
 pkgconf,
 libibverbs-dev (>= 1.1.7) [!hurd-any],
 libfabric-dev [!hurd-any],
 libnuma-dev [!hurd-any],
 libpsm2-dev [amd64],
 python3-sphinx-rtd-theme:native,
 sphinx,
 python3-recommonmark:native,
 default-jdk [!hurd-any !alpha !ppc64 !sparc64] <!nojava>,
 chrpath,
 flex
Build-Conflicts: libmpich-dev, libopenmpi-dev
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://www.open-mpi.org/
Vcs-Browser: https://salsa.debian.org/hpc-team/openmpi
Vcs-Git: https://salsa.debian.org/hpc-team/openmpi.git -b debian/latest

Package: openmpi-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, openmpi-common (>= ${source:Version}),
 openssh-client | ssh-client
Suggests: gfortran | fortran-compiler
Description: high performance message passing library -- binaries
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-3.1 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 Features:
  * Full MPI-3.1 standards conformance
  * Thread safety and concurrency
  * Dynamic process spawning
  * High performance on all platforms
  * Reliable and fast job management
  * Network and process fault tolerance
  * Support network heterogeneity
  * Single library supports all networks
  * Run-time instrumentation
  * Many job schedulers supported
  * Internationalized error messages
  * Component-based design, documented APIs
 .
 This package contains the Open MPI utility programs.

Package: libopenmpi-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${fortran:Depends},
 libopenmpi40 (= ${binary:Version}), 
 openmpi-common (>= ${source:Version}), 
 libibverbs-dev (>= 1.1.7) [!hurd-any], libhwloc-dev,
 libevent-dev, 
 libjs-jquery,
 libjs-jquery-ui,
 zlib1g-dev,
 openmpi-bin (>= 3.0.0-1)
Recommends: libcoarrays-openmpi-dev
Suggests: openmpi-doc
Description: high performance message passing library -- header files
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-3 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 This package contains the header files and compiler wrappers which are needed
 to compile and link programs against libopenmpi.

Package: libopenmpi40
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libhwloc-plugins
Description: high performance message passing library -- shared library
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-3.1 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 This package contains the Open MPI shared libraries.

Package: openmpi-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: high performance message passing library -- common files
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-3.1 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 This package contains platform independent files for Open MPI.

Package: openmpi-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, 
 ${sphinxdoc:Depends}, 
 node-mathjax-full,
 fonts-font-awesome
Conflicts: mpi-doc, lam-mpidoc, lam4-dev
Built-Using: ${sphinxdoc:Built-Using}
Description: high performance message passing library -- man pages
 Open MPI is a project combining technologies and resources from several other
 projects (FT-MPI, LA-MPI, LAM/MPI, and PACX-MPI) in order to build the best
 MPI library available. A completely new MPI-3.1 compliant implementation, Open
 MPI offers advantages for system and software vendors, application developers
 and computer science researchers.
 .
 This package contains man pages describing the Message Passing Interface
 standard.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# This needed for cross-builds but breaks mpicc. Why? 2025-08-30
# DPKG_EXPORT_BUILDTOOLS = 1
# include /usr/share/dpkg/buildtools.mk

DESTDIR:=$(CURDIR)/debian/tmp/
BUILDDIR_FLANG=debian/build-flang
BUILDDIR_GFORTRAN=debian/build-gfortran
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
AUTOGENERATED:= libopenmpi-dev.postinst libopenmpi-dev.prerm

### Arch-specific stuff
# No ibverbs support available on kFreeBSD, Hurd
NO_VERBS_ARCH:= hurd-amd64 s390x 
NO_FABRIC_ARCH:=hurd-amd64 s390x 
PSM2_ARCH:= amd64
UCX_ARCH:= amd64 ppc64el arm64 riscv64 loong64
ATOMICS_ARCH:= s390x riscv64
NO_CMA_ARCH:= s390x alpha sparc64
NO_JAVA_ARCH:= hurd-amd64 ppc64 alpha sparc64
NO_TEST_ARCH:= hurd-amd64


UCX:=     $(if $(filter $(DEB_TARGET_ARCH), $(UCX_ARCH)),  --with-ucx,  )
VERBS:=   $(if $(filter $(DEB_TARGET_ARCH), $(NO_VERBS_ARCH)), , --with-verbs ) 
FABRIC:=  $(if $(filter $(DEB_TARGET_ARCH), $(NO_FABRIC_ARCH)),  , --with-libfabric  )
PSM2:=    $(if $(filter $(DEB_TARGET_ARCH), $(PSM2_ARCH)),  --with-psm2, )
ATOMICS:= $(if $(filter $(DEB_TARGET_ARCH), $(ATOMICS_ARCH)), --enable-builtin-atomics, )
CMA:=     $(if $(filter $(DEB_TARGET_ARCH), $(NO_CMA_ARCH)), --without-cma , )
DO_TEST:= $(if $(filter $(DEB_TARGET_ARCH), $(NO_TEST_ARCH)), false, true)
BTL_TESTS:= $(if $(DO_TEST), --enable-opal-btl-usnic-unit-tests, )
DO_FLANG:=$(if $(wildcard /usr/bin/flang),true, false)

ifeq ($(filter nojava,$(DEB_BUILD_PROFILES)),)
       JAVA := $(if $(filter $(DEB_TARGET_ARCH), $(NO_JAVA_ARCH)), \
		 ,--with-jdk-dir=/usr/lib/jvm/default-java --enable-mpi-java )
endif

FLANG_FCFLAGS= $(filter '-g', $(shell dpkg-buildflags --get FCFLAGS))
FLANG_LIBDIR= $(LIBDIR)/fortran/flang

FLANG_VERSION=$(shell basename $(shell readlink /usr/bin/flang))
# GFORTRAN_VERSION:=$(shell basename $(shell readlink -f /usr/bin/gfortran))
export GFORTRAN_MOD_VERSION=gfortran-mod-16

FMODDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)/fortran/$(GFORTRAN_MOD_VERSION)
# arch-neutral version we can put in openmpi-common configs
FMODDIR_STRING:="\${libdir}/fortran/$(GFORTRAN_MOD_VERSION)"

# Drop '-g' flag with flang. Known failure with 2018122 version
ifneq ($(filter flang,$(FC)),)
FCFLAGS=$(shell dpkg-buildflags --get FCLAGS |  sed -e 's/-g //')
endif


ifeq (sparc,$(DEB_HOST_GNU_CPU))
	CFLAGS += -mcpu=v9
endif

# Use -O3 recommended by upstream
CFLAGS += -O3
CXXFLAGS += -O3
FCFLAGS += -O3

# Flags for the static build: see bug #502232
#STATIC_CONFIG_PARAMS = --enable-static
STATIC_CONFIG_PARAMS =  

# Do not embed build username or build system hostname, see README
export HOSTNAME=hostname
export USER=username

%:
	dh $@ --with sphinxdoc

extra_flags = \
		--disable-silent-rules \
		--disable-wrapper-runpath \
		--with-package-string="Debian OpenMPI" \
		$(VERBS) $(FABRIC) $(PSM2) $(CMA) \
		$(UCX) \
		$(ATOMICS) \
		$(JAVA) \
		$(STATIC_CONFIG_PARAMS) \
		$(BTL_TESTS) \
		--with-pmix=external \
                --with-libevent=external \
		--with-hwloc=external  \
		--disable-silent-rules \
		--enable-ipv6  \
		--with-devel-headers \
		--with-slurm \
		--with-sge \
		--without-tm \
		--sysconfdir=/etc/openmpi 		\
		--libdir=\$${prefix}/lib/${DEB_HOST_MULTIARCH}/openmpi/lib	\
		--includedir=\$${prefix}/lib/${DEB_HOST_MULTIARCH}/openmpi/include 

override_dh_auto_clean:
	dh_clean
	rm -fr debian/build-*
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	find . -name Makefile.in -delete
	find . -name .libs -exec rm -rf {} \; || true
	find . -name .dirstamp -delete
	find . -type l -delete
	find . -name '*.o' -delete

override_dh_update_autotools_config:
	(cd config && autom4te --language=m4sh opal_get_version.m4sh -o opal_get_version.sh)
	./autogen.pl --force

override_dh_autoreconf:
	@echo Skipping extra autoreconf.

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
               sed -e 's%@DEB_HOST_MULTIARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  | \
               sed -e 's/@GFORTRAN_VERSION@/${GFORTRAN_VERSION}/' > debian/$$f ; \
               done
	dh_auto_configure --builddirectory=$(BUILDDIR_GFORTRAN) -- $(extra_flags)
	$(DO_FLANG) && dh_auto_configure --builddirectory=$(BUILDDIR_FLANG) \
		-- $(extra_flags) FC=flang FCFLAGS="$(FLANG_FCFLAGS)" || true

override_dh_auto_build:
	dh_auto_build --builddirectory=$(BUILDDIR_GFORTRAN)	
	$(DO_FLANG) && dh_auto_build --builddirectory=$(BUILDDIR_FLANG)	 || true

override_dh_install:
	dh_auto_install --builddirectory=$(BUILDDIR_GFORTRAN)
	$(DO_FLANG) && find $(BUILDDIR_FLANG) -type f -perm -+x -a ! -name '*.la' -a ! -name '*.mod' -exec chrpath -d '{}' \; || true
# Rename the compiler and startup wrappers.
	for f in mpic++ mpicc mpiCC mpicxx mpiexec mpif77 mpif90 mpirun mpifort ; do \
		if test -f $(DESTDIR)/usr/bin/$${f}; then \
			mv $(DESTDIR)/usr/bin/$${f} $(DESTDIR)/usr/bin/$${f}.openmpi ; \
		fi; \
	done
	# Rename some files
	#mv $(DESTDIR)/usr/bin/aggregate_profile.pl $(DESTDIR)/usr/bin/aggregate_profile
	#mv $(DESTDIR)/usr/bin/profile2mat.pl $(DESTDIR)/usr/bin/profile2mat
	mv $(DESTDIR)/usr/bin/pterm	$(DESTDIR)/usr/bin/pterm.openmpi
	mv $(DESTDIR)/usr/share/man/man1/pterm.1 $(DESTDIR)/usr/share/man/man1/pterm.openmpi.1
	# Ensure correct mpiexec is used
	rm $(DESTDIR)/usr/bin/mpiexec.openmpi $(DESTDIR)/usr/bin/oshrun
	ln -s mpirun.openmpi $(DESTDIR)/usr/bin/mpiexec.openmpi
	ln -s mpirun.openmpi $(DESTDIR)/usr/bin/oshrun
# Strip rpath from pc,wrapper files
	for f in ompi-c.pc  ompi-cxx.pc  ompi-f77.pc  ompi-f90.pc  ompi-fort.pc  ompi.pc  opal.pc  oshmem-c.pc  oshmem-cxx.pc  oshmem-fort.pc  oshmem.pc ; do  \
		sed -e 's/-Wl,-rpath -Wl,$${libdir}//' < $(DESTDIR)/$(LIBDIR)/openmpi/lib/pkgconfig/$${f} | \
                sed -e 's%@FMODDIR@%${FMODDIR_STRING}%g' > debian/tmp.x ; \
		mv debian/tmp.x $(DESTDIR)/$(LIBDIR)/openmpi/lib/pkgconfig/$${f} ; \
		done
	find . -name '*wrapper-data.txt' | while read f; do \
		sed -e 's%$${prefix}/lib/${DEB_HOST_MULTIARCH}%$${libdir}%g' <  $$f | \
		sed -e 's/-Wl,-rpath -Wl,$${libdir}//' | \
		sed -e 's%@FMODDIR@%${FMODDIR_STRING}%g' > debian/tmp.x ; \
		mv debian/tmp.x $$f ; done
# Rename the compiler wrapper man pages.
	for f in mpic++ mpicc mpicxx mpiexec mpif77 mpif90 mpirun mpifort ; do \
		if test -f $(DESTDIR)/usr/share/man/man1/$${f}.1; then \
			mv $(DESTDIR)/usr/share/man/man1/$${f}.1 $(DESTDIR)/usr/share/man/man1/$${f}.openmpi.1 ; \
		fi; \
		if test -f $(DESTDIR)/usr/share/man/man1/$${f}.3; then \
			mv $(DESTDIR)/usr/share/man/man3/$${f}.3 $(DESTDIR)/usr/share/man/man1/$${f}.openmpi.3 ; \
		fi; \
	done
	cd $(DESTDIR)/usr/share/man/man3; \
	for f in *.3; do \
		mv $$f $$(echo $$f|sed -e "s|\.3|.openmpi.3|g"); \
	done; \
	mkdir -p $(DESTDIR)/$(LIBDIR)/openmpi/lib/
	cp $(BUILDDIR_GFORTRAN)/ompi/mpi/fortran/*/.libs/libmpi_mpifh.so.40.40.1  $(DESTDIR)/$(LIBDIR)/openmpi/lib/libmpi_mpifh.so.40.40.1
	cp $(BUILDDIR_GFORTRAN)/ompi/mpi/fortran/*/.libs/libmpi_usempi_ignore_tkr.so.40.40.1 $(DESTDIR)/$(LIBDIR)/openmpi/lib/libmpi_usempi_ignore_tkr.so.40.40.1
	cp $(BUILDDIR_GFORTRAN)/ompi/mpi/fortran/*/.libs/libmpi_usempif08.so.40.40.3 $(DESTDIR)/$(LIBDIR)/openmpi/lib/libmpi_usempif08.so.40.40.3
	gcc -shared -fPIC -Wl,-soname,libmpi_mpifh-gfortran.so.40 -o $(DESTDIR)/$(LIBDIR)/openmpi/lib/libmpi_mpifh-gfortran.so.40.40.1 \
               $(DESTDIR)/$(LIBDIR)/openmpi/lib/libmpi_mpifh.so.40.40.1
	gcc -shared -fPIC -Wl,-soname,libmpi_usempi_ignore_tkr-gfortran.so.40 \
		-o $(DESTDIR)/$(LIBDIR)/openmpi/lib/libmpi_usempi_ignore_tkr-gfortran.so.40.40.1 \
		   $(DESTDIR)/$(LIBDIR)/openmpi/lib/libmpi_usempi_ignore_tkr.so.40.40.1
	gcc -shared -fPIC -Wl,-soname,libmpi_usempif08-gfortran.so.40 -o $(DESTDIR)/$(LIBDIR)/openmpi/lib/libmpi_usempif08-gfortran.so.40.40.3 \
		$(DESTDIR)/$(LIBDIR)/openmpi/lib/libmpi_usempif08.so.40.40.3
	dh_fortran_mod -p libopenmpi-dev  $(BUILDDIR_GFORTRAN)/ompi/mpi/fortran/mpiext/*.mod openmpi
	# Flang, if present
	$(DO_FLANG) && ( \

=== debian/watch ===
version=4
http://www.open-mpi.org/software/ompi/ .*/.*/openmpi-([\d+\.]+)@ARCHIVE_EXT@

## openmpi 5.0.10

=== 3rd-party/prrte/examples/Makefile ===
--- 
+++ 
@@ -63,7 +63,7 @@
 	pset \
 	nodeid \
 	client-threaded \
-|	abort
+	abort
 
 all: $(EXAMPLES)

=== debian/changelog ===
openmpi (5.0.10-1) unstable; urgency=medium

  * New upstream release
  * Include mofed files in d/source that get deleted by pristine-tar import

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 03 Mar 2026 06:52:48 +0000

openmpi (5.0.9-6) unstable; urgency=medium

  * mpirun requires libprrte-bin to be installed

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 27 Feb 2026 06:44:10 +0000

openmpi (5.0.9-5) unstable; urgency=medium

  * Drop debian/libopenmpi3t64.lintian-overrides
  * Build-dep on libpmix-bin for pmixcc (LTO support)
  * cme: paths should not lead with '/'
  * Use external prrte

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 26 Feb 2026 14:08:31 +0000

openmpi (5.0.9-4) experimental; urgency=medium

  * Build with UCC (Unified collectives) support

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 14 Feb 2026 09:05:32 +0000

openmpi (5.0.9-3) unstable; urgency=medium

  * Standards-Version: 4.7.3
  * d/control: Priority optional dropped
  * d/control: updated depends with 'cme fix'
  * Use pre-computed DEB_HOST_MULTIARCH
  * d/gbp.conf: upstream is default for DEP-14

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 14 Feb 2026 09:05:14 +0000

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,7 @@
 
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
+include /usr/share/dpkg/architecture.mk
 
 # This needed for cross-builds but breaks mpicc. Why? 2025-08-30
 # DPKG_EXPORT_BUILDTOOLS = 1
@@ -12,7 +13,6 @@
 DESTDIR:=$(CURDIR)/debian/tmp/
 BUILDDIR_FLANG=debian/build-flang
 BUILDDIR_GFORTRAN=debian/build-gfortran
-DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
 AUTOGENERATED:= libopenmpi-dev.postinst libopenmpi-dev.prerm
 
@@ -22,6 +22,7 @@
 NO_FABRIC_ARCH:=hurd-amd64 s390x 
 PSM2_ARCH:= amd64
 UCX_ARCH:= amd64 ppc64el arm64 riscv64 loong64
+UCC_ARCH:= amd64 ppc64el arm64 riscv64
 ATOMICS_ARCH:= s390x riscv64
 NO_CMA_ARCH:= s390x alpha sparc64
 NO_JAVA_ARCH:= hurd-amd64 ppc64 alpha sparc64
@@ -29,6 +30,7 @@
 
 
 UCX:=     $(if $(filter $(DEB_TARGET_ARCH), $(UCX_ARCH)),  --with-ucx,  )
+UCC:=     $(if $(filter $(DEB_TARGET_ARCH), $(UCC_ARCH)),  --with-ucc,  )
 VERBS:=   $(if $(filter $(DEB_TARGET_ARCH), $(NO_VERBS_ARCH)), , --with-verbs ) 
 FABRIC:=  $(if $(filter $(DEB_TARGET_ARCH), $(NO_FABRIC_ARCH)),  , --with-libfabric  )
 PSM2:=    $(if $(filter $(DEB_TARGET_ARCH), $(PSM2_ARCH)),  --with-psm2, )
@@ -86,11 +88,13 @@
 		--with-package-string="Debian OpenMPI" \
 		$(VERBS) $(FABRIC) $(PSM2) $(CMA) \
 		$(UCX) \
+		$(UCC) \
 		$(ATOMICS) \
 		$(JAVA) \
 		$(STATIC_CONFIG_PARAMS) \
 		$(BTL_TESTS) \
 		--with-pmix=external \
+		--with-prrte=$(LIBDIR)/prrte3 \
                 --with-libevent=external \
 		--with-hwloc=external  \
 		--disable-silent-rules \
@@ -106,6 +110,7 @@
 override_dh_auto_clean:
 	dh_clean
 	rm -fr debian/build-*
+	rm -rf contrib/dist/mofed/debian
 	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
 	find . -name Makefile.in -delete
 	find . -name .libs -exec rm -rf {} \; || true
@@ -114,6 +119,7 @@
 	find . -name '*.o' -delete
 
 override_dh_update_autotools_config:
+	cp -a debian/source/mofed/debian contrib/dist/mofed
 	(cd config && autom4te --language=m4sh opal_get_version.m4sh -o opal_get_version.sh)
 	./autogen.pl --force
 
@@ -145,8 +151,6 @@
 	# Rename some files
 	#mv $(DESTDIR)/usr/bin/aggregate_profile.pl $(DESTDIR)/usr/bin/aggregate_profile
 	#mv $(DESTDIR)/usr/bin/profile2mat.pl $(DESTDIR)/usr/bin/profile2mat
-	mv $(DESTDIR)/usr/bin/pterm	$(DESTDIR)/usr/bin/pterm.openmpi
-	mv $(DESTDIR)/usr/share/man/man1/pterm.1 $(DESTDIR)/usr/share/man/man1/pterm.openmpi.1
 	# Ensure correct mpiexec is used
 	rm $(DESTDIR)/usr/bin/mpiexec.openmpi $(DESTDIR)/usr/bin/oshrun
 	ln -s mpirun.openmpi $(DESTDIR)/usr/bin/mpiexec.openmpi
@@ -186,6 +190,3 @@
 		   $(DESTDIR)/$(LIBDIR)/openmpi/lib/libmpi_usempi_ignore_tkr.so.40.40.1
 	gcc -shared -fPIC -Wl,-soname,libmpi_usempif08-gfortran.so.40 -o $(DESTDIR)/$(LIBDIR)/openmpi/lib/libmpi_usempif08-gfortran.so.40.40.3 \
 		$(DESTDIR)/$(LIBDIR)/openmpi/lib/libmpi_usempif08.so.40.40.3
-	dh_fortran_mod -p libopenmpi-dev  $(BUILDDIR_GFORTRAN)/ompi/mpi/fortran/mpiext/*.mod openmpi
-	# Flang, if present
-	$(DO_FLANG) && ( \
